#! usr/bin/env python3

'''
This script is used to extract the sequence of the target gene ID from the fasta file
'''

import sys
import getopt

opts, args = getopt.getopt(sys.argv[1:],'-s:-i:-o:-h',['seqfile=','idfile=','outputfile=','help'])

def usage():
	print('usage : python3 script -i inputfile -o outputfile -h help infor')

for opt_name,opt_value in opts:
	if opt_name in ('-h','--help'):
		usage()
		sys.exit()
	if opt_name in ('-s','--seqfile'):
		seqfile = opt_value
	if opt_name in ('-i','--idfile'):
		idfile = opt_value
	if opt_name in ('-o','--output'):
		outputfile = opt_value

def seqfile2dict_func(seqfile):
	in_f = open (seqfile,'r')
	fasta_dict = {}
	key = in_f.readline().strip().split('\t')[0].replace('>','')
	seq = ''
	for lin in in_f:
		if lin.startswith('>'):
			fasta_dict[key] = seq
			key =lin.strip().split('\t')[0].replace('>','')
			seq = ''
		else:
			seq += lin.strip()
	fasta_dict[key] = seq
	return fasta_dict

def idfile2arrs_func(idfile):
	in_f = open(idfile,'r')
	id_arrs = []
	for lin in in_f:
		id_arrs.append(lin.strip())
	return id_arrs
		
def id2seq_func(fast_dict,id_arrs,outputfile):
	out_f = open(outputfile,'w')
	for id_arr in id_arrs:
		out_f.write('>' + id_arr + '\n' + fast_dict[id_arr] + '\n')
		
	
	
if __name__ == '__main__':
	fasta_dict = seqfile2dict_func(seqfile)
	id_arrs = idfile2arrs_func(idfile)
	id2seq_func(fasta_dict,id_arrs,outputfile)
	




