#! usr/bin/env python3

#This script is used to calculate KaKs

import sys
import getopt
import os
import shutil

opts, args = getopt.getopt(sys.argv[1:],'-c:-p:-l:-o:-d:-h',['cdsfile=','pepfile=','listfile=','outpufile=','dirname=','help'])

def usage():
	print('usage : python3 script -c cdsfile -p pepfile -l listfile -o outputfile -d dirname -h help infor')

for opt_name,opt_value in opts:
	if opt_name in ('-h','--help'):
		usage()
		sys.exit()
	if opt_name in ('-c','--cdsfile'):
		cdsfile = opt_value
	if opt_name in ('-p','--pepfile'):
		pepfile = opt_value
	if opt_name in ('-l','--listfile'):
		listfile = opt_value
	if opt_name in ('-d','--dirname'):
		dirname = opt_value
	if opt_name in ('-o','--output'):
		outputfile = opt_value

def seqfile2dict_func(seqfile):
	in_f = open (seqfile,'r')
	fasta_dict = {}
	key = in_f.readline().strip().split('\t')[0].replace('>','')
	seq = ''
	for lin in in_f:
		if lin.startswith('>'):
			fasta_dict[key] = seq
			key =lin.strip().split('\t')[0].replace('>','')
			seq = ''
		else:
			seq += lin.strip()
	fasta_dict[key] = seq
	return fasta_dict

def idfile2arrs_func(idfile):
	in_f = open(idfile,'r')
	id_arrs = []
	for lin in in_f:
		infor = lin.strip().split('\t')[0] + '_' +lin.strip().split('\t')[1] 
		id_arrs.append(lin.strip())
	return id_arrs	

def mkdir_func(dir):
	mkdir = os.getcwd() + '/' + dir
	if os.path.exists(mkdir):
		shutil.rmtree(mkdir, ignore_errors = True)
		os.makedirs(mkdir)
	else:
		os.makedirs(mkdir)

def pep2clustalo_func(pep_dict,cds_dict,id_arrs,clustalo_dir):
	for arr in id_arrs:
		outfile_name_fix = os.getcwd() + '/' + clustalo_dir + '/' + arr.split('\t')[0] + '_' + arr.split('\t')[1]  
		outf_pep = open(outfile_name_fix + '.pep' , 'w')
		outinfor_pep = ">" + arr.split('\t')[0] + '\n' + pep_dict[arr.split('\t')[0]] + '\n' +">" + arr.split('\t')[1] + '\n' + pep_dict[arr.split('\t')[1]] 
		outf_pep.write(outinfor_pep)
		outf_pep.close()
		os.system('clustalo -i %s.pep -o %s.aln\n' % (outfile_name_fix, outfile_name_fix) )
		
		outf_cds = open(outfile_name_fix + '.cds' , 'w')
		outinfor_cds = ">" + arr.split('\t')[0] + '\n' + cds_dict[arr.split('\t')[0]] + '\n' +">" + arr.split('\t')[1] + '\n' + cds_dict[arr.split('\t')[1]]
		outf_cds.write(outinfor_cds)
		outf_cds.close()
		
		outf_tree = open(outfile_name_fix + '.tree','w')
		outinfor_tree = "("+ arr.split('\t')[0] +  ','  + arr.split('\t')[1] + ");"
		outf_tree.write(outinfor_tree)
		outf_tree.close()
		
		os.system("perl /home/cuilicao/software/pal2nal.v14/pal2nal.pl %s.aln %s.cds -output paml -nogap > %s.codon" % (outfile_name_fix, outfile_name_fix,outfile_name_fix))
		
		outf_cnt = open(outfile_name_fix + '.cnt', 'w')
		outinfor_cnt = "seqfile = " + outfile_name_fix + ".codon\n" + "treefile = " + outfile_name_fix + ".tree\n" + "outfile = " + outfile_name_fix + ".codeml\n"
		outf_cnt.write(outinfor_cnt)
		outf_cnt.write("noisy = 0\nverbose = 0\nrunmode = -2\ncleandata = 1\nseqtype = 1\nCodonFreq = 2\nmodel = 2\nNSsites = 0\nicode = 0\nMgene = 0\n")
		outf_cnt.write("fix_kappa = 0\nkappa = 2\nfix_omega = 0\nomega = 1\nfix_alpha = 1\nalpha = .0\nMalpha = 0\nncatG = 4\nclock = 0\ngetSE = 0\nRateAncestor = 0\nmethod = 0\n")
		outf_cnt.close()
		
		#os.system('echo -ne "codeml ./%s.cnt\n"' % (clustalo_dir + '/' + arr.split('\t')[0] + '_' + arr.split('\t')[1]))
		os.system("codeml ./%s.cnt\n" % (clustalo_dir + '/' + arr.split('\t')[0] + '_' + arr.split('\t')[1]))
		
if __name__ == '__main__':
	cds_dict = seqfile2dict_func(cdsfile)
	pep_dict = seqfile2dict_func(pepfile)
	id_arrs = idfile2arrs_func(listfile)
	
	clustalo_dir = dirname
	mkdir_func(clustalo_dir)
	pep2clustalo_func(pep_dict,cds_dict,id_arrs,clustalo_dir)












