#! usr/bin/env pythons

'''
This script is used to calculate the GC content
'''

import sys
import getopt

opts, args = getopt.getopt(sys.argv[1:],'-i:-o:',['inputfile=','outputfile='])

def usage():
	print('usage : python3 script -i inputfile -o outputfile -h help infor')


for opt_name, opt_value in opts:
	if opt_name in ('-h','--help'):
		usage()
		sys.exit()
	if opt_name in ('-i','--inputfile'):
		inputfile = opt_value
	if opt_name in ('-o','--outpufile'):
		outputfile = opt_value

def fasta2dict_func(inputfile):
	in_f = open (inputfile,'r')
	fasta_dict = {}
	key = in_f.readline().strip().split('\t')[0].replace('>','').split('.')[0]
	seq = ''
	for lin in in_f:
		if lin.startswith('>'):
			fasta_dict[key] = seq
			key =lin.strip().split('\t')[0].replace('>','').split('.')[0]
			seq = ''
		else:
			seq += lin.strip()
	fasta_dict[key] = seq
	return fasta_dict
	
def gc_cal_func(fasta_dict,outputfile):
	outf = open(outputfile,'w')
	outf.write("Gene_ID\tGC_conten\n")
	for k,v in fasta_dict.items():
		gc_content = (v.upper().count('G') + v.upper().count('C')) / len(v)
		outf.write(k + '\t' + str(gc_content) + '\n')
		
		
if __name__ == '__main__':
	fasta_dict = fasta2dict_func(inputfile)
	gc_cal_func(fasta_dict,outputfile)
	
	



