#! usr/bin/env python3

# This script is used to evaluate the tissue specificity index based on FPKM

import sys
import getopt
from itertools import islice

opts, args = getopt.getopt(sys.argv[1:],'-i:-o:-h',['inputfile=','outputfile=','help'])

def usage():
	print('usage : python3 script -i inputfile -o outputfile -h')

for opt_name,opt_value in opts:
	if opt_name in ('-h','--help'):
		usage()
		sys.exit()
	if opt_name in ('-i','--inputfile'):
		inputfile = opt_value
	if opt_name in ('-o','--output'):
		outputfile = opt_value

def inf_func(inputfile):
	inf = open(inputfile, 'r')
	arrs = []
	for lin in islice(inf,1,None):
		arrs.append(lin.strip())
	return arrs	

def Tao_cal_func(arrs, outputfile):
	outf = open(outputfile, 'w')
	outf.write('Gene\tExpression_Level\tTao\n')
	for arr in arrs:
		#tmps = arr.split('\t')
		fpkms = list(map(float,arr.split('\t')[1:]))
		fpkm_max = max(fpkms) 
		sigma = 0
		if fpkm_max != 0:
			for fpkm in fpkms:
				sigma += 1 - fpkm/fpkm_max
			tao = sigma / (len(fpkms)-1)
		else:
			tao = 0
		
		aver = sum(fpkms) / len(fpkms)
		#print(aver)
		outf.write(arr.split('\t')[0] + '\t' + str(aver) + '\t' + str(tao) + '\n')
		#print(arr.split('\t')[0])


if __name__ == '__main__':
	arrs = inf_func(inputfile)
	Tao_cal_func(arrs, outputfile)



