#!/usr/bin/bash

# This script is used for SNP annotation

java -jar snpEff.jar build -c snpEff.config -gff3 -v Ta_whole

vcfdir=/jscratch/cuilicao/01.wheat_duplication/08.var/00.data
for chr in 1 2 3 4 5 6 7
do
	for sub in A B D
	do
		echo -ne "$chr$sub\n"
		java -Xmx50G -jar snpEff.jar eff \
		-c snpEff.config Ta_whole  \
		-no-intergenic -no-downstream -no-upstream\
		$vcfdir/chr${chr}${sub}.vcf  > chr${chr}${sub}.snp.eff.vcf -csvStats chr${chr}${sub}.csv -stats chr${chr}${sub}.html
		grep "TraesCS" chr${chr}${sub}.snp.eff.vcf > chr${chr}${sub}.snp.eff.genic_region.vcf
	done
done
