#!/usr/bin/bash

# This script is used to calculate the  and Fst

vcfdir=/jscratch/cuilicao/01.wheat_duplication/08.var/00.snpeff
listdir=/jscratch/cuilicao/01.wheat_duplication/08.var/00.list
for chr in 1 2 3 4 5 6 7
do	
	cat list.id | while read list
	do
		echo -ne "$chr\t$list\n"
		vcftools --vcf ${vcfdir}/chr${chr}A.snp.eff.vcf --window-pi 1000000 --window-pi-step 100000 --keep $listdir/$list --out chr${chr}A.${list%.list}.1Mwin_100Kstep
	done
done

for chr in 1 2 3 4 5 6 7
do	
	cat list.id | while read list
	do
		echo -ne "$chr\t$list\n"
		vcftools --vcf ${vcfdir}/chr${chr}B.snp.eff.vcf --window-pi 1000000 --window-pi-step 100000 --keep $listdir/$list --out chr${chr}B.${list%.list}.1Mwin_100Kstep
	done
done

for chr in 1 2 3 4 5 6 7
do	
	cat list.id | while read list
	do
		echo -ne "$chr\t$list\n"
		vcftools --vcf ${vcfdir}/chr${chr}D.snp.eff.vcf --window-pi 1000000 --window-pi-step 100000 --keep $listdir/$list --out chr${chr}D.${list%.list}.1Mwin_100Kstep
	done
done



##############################################################################################################
vcfdir=/jscratch/cuilicao/01.wheat_duplication/08.var/00.snpeff
listdir=/jscratch/cuilicao/01.wheat_duplication/08.var/00.list
for chr in 1 2 3 4 5 6 7
do	
	echo -ne "$chr\t$list\n"
	vcftools --vcf  ${vcfdir}/chr${chr}A.snp.eff.vcf   --weir-fst-pop $listdir/0.Wild_emmer.list  --weir-fst-pop $listdir/1.Domesticated_emmer.list \
	--fst-window-size 1000000  --fst-window-step 100000 --out  chr${chr}A.Wild_emmer_vs_Domesticated_emmer.1Mwin_100Kstep

	vcftools --vcf  ${vcfdir}/chr${chr}A.snp.eff.vcf   --weir-fst-pop $listdir/1.Domesticated_emmer.list  --weir-fst-pop $listdir/2.Durum.list \
	--fst-window-size 1000000  --fst-window-step 100000 --out  chr${chr}A.Domesticated_emmer_vs_Durum.1Mwin_100Kstep

	vcftools --vcf  ${vcfdir}/chr${chr}A.snp.eff.vcf   --weir-fst-pop $listdir/7.AABB.list --weir-fst-pop $listdir/9.AABBDD.list \
	--fst-window-size 1000000  --fst-window-step 100000 --out  chr${chr}A.AABB_vs_AABBDD.1Mwin_100Kstep
done

for chr in 1 2 3 4 5 6 7
do	
	echo -ne "$chr\t$list\n"
	vcftools --vcf  ${vcfdir}/chr${chr}B.snp.eff.vcf   --weir-fst-pop $listdir/0.Wild_emmer.list  --weir-fst-pop $listdir/1.Domesticated_emmer.list \
	--fst-window-size 1000000  --fst-window-step 100000 --out  chr${chr}B.Wild_emmer_vs_Domesticated_emmer.1Mwin_100Kstep

	vcftools --vcf  ${vcfdir}/chr${chr}B.snp.eff.vcf   --weir-fst-pop $listdir/1.Domesticated_emmer.list  --weir-fst-pop $listdir/2.Durum.list \
	--fst-window-size 1000000  --fst-window-step 100000 --out  chr${chr}B.Domesticated_emmer_vs_Durum.1Mwin_100Kstep

	vcftools --vcf  ${vcfdir}/chr${chr}B.snp.eff.vcf   --weir-fst-pop $listdir/7.AABB.list --weir-fst-pop $listdir/9.AABBDD.list \
	--fst-window-size 1000000  --fst-window-step 100000 --out  chr${chr}B.AABB_vs_AABBDD.1Mwin_100Kstep
done

for chr in 1 2 3 4 5 6 7
do	
echo -ne "$chr\t$list\n"
	vcftools --vcf  ${vcfdir}/chr${chr}D.snp.eff.vcf   --weir-fst-pop $listdir/8.DD.list  --weir-fst-pop $listdir/9.AABBDD.list \
	--fst-window-size 1000000  --fst-window-step 100000 --out  chr${chr}D.DD_vs_AABBDD.1Mwin_100Kstep
done
